C3DFVectorfield Class Reference
Basic data strctures and functions

a 3D field of floating point single accuracy 3D vectors More...

`#include <mia/3d/vectorfield.hh>`

Inheritance diagram for C3DFVectorfield:
[legend]
Collaboration diagram for C3DFVectorfield:
[legend]

## Public Member Functions

void | update_as_inverse_of (const C3DFVectorfield &other, float tol, int maxiter)
| evaluate this vector field as the inverse of another
void | update_by_velocity (const C3DFVectorfield &velocity_field, float time_step)
Public Member Functions inherited from T3DVectorfield< C3DFVector >
C3DFVector | get_interpol_val_at (const C3DFVector &p) const
C3DFVector | get_voxel_size () const
void | set_voxel_size (const C3DFVector &voxel)
| T3DVectorfield ()
Public Member Functions inherited from T3DDatafield< C3DFVector >
const_iterator | begin () const
const_iterator | begin_at (size_t x, size_t y, size_t z) const
range_iterator | begin_range (const C3DBounds &begin, const C3DBounds &end)
range_iterator_with_boundary_flag | begin_range_with_boundary_flags (const C3DBounds &begin, const C3DBounds &end)
void | clear ()
const_iterator | end () const
range_iterator | end_range (const C3DBounds &begin, const C3DBounds &end)
range_iterator_with_boundary_flag | end_range_with_boundary_flags (const C3DBounds &begin, const C3DBounds &end)
value_type | get_avg ()
value_type | get_block_avrg (const C3DBounds &Start, const C3DBounds &BlockSize) const
void | get_data_line_x (int y, int z, std::vector< C3DFVector > &buffer) const
void | get_data_line_y (int x, int z, std::vector< C3DFVector > &buffer) const
void | get_data_line_z (int x, int y, std::vector< C3DFVector > &buffer) const
T2DDatafield< C3DFVector > | get_data_plane_xy (size_t z) const
T2DDatafield< C3DFVector > | get_data_plane_xz (size_t y) const
T2DDatafield< C3DFVector > | get_data_plane_yz (size_t x) const
T3DVector< Out > | get_gradient (int hardcode) const
value_type | get_interpol_val_at (const T3DVector< float > &p) const __attribute__((deprecated))
size_t | get_plane_size_xy () const
Range | get_range (const C3DBounds &start, const C3DBounds &end)
const C3DBounds & | get_size () const
bool | holds_unique_data () const __attribute__((deprecated))
void | make_single_ref () __attribute__((deprecated))
void | mask (const TMask &m)
const_reference | operator() (size_t x, size_t y, size_t z) const
T3DDatafield & | operator= (const T3DDatafield &org)
const_reference | operator[] (int i) const
void | put_data_line_x (int y, int z, const std::vector< C3DFVector > &buffer)
void | put_data_line_y (int x, int z, const std::vector< C3DFVector > &buffer)
void | put_data_line_z (int x, int y, const std::vector< C3DFVector > &buffer)
void | put_data_plane_xy (size_t z, const T2DDatafield< C3DFVector > &p)
void | put_data_plane_xz (size_t y, const T2DDatafield< C3DFVector > &p)
void | put_data_plane_yz (size_t x, const T2DDatafield< C3DFVector > &p)
void | read_xslice_flat (size_t x, std::vector< atomic_type > &buffer) const
void | read_yslice_flat (size_t y, std::vector< atomic_type > &buffer) const
void | read_zslice_flat (size_t z, std::vector< atomic_type > &buffer) const
size_type | size () const
value_type | strip_avg ()
void | swap (T3DDatafield &other)
| swap the data ofthis 3DDatafield with another one
| T3DDatafield ()
void | write_xslice_flat (size_t x, const std::vector< atomic_type > &buffer)
void | write_yslice_flat (size_t y, const std::vector< atomic_type > &buffer)
void | write_zslice_flat (size_t z, const std::vector< atomic_type > &buffer)
virtual | ~T3DDatafield ()
| make sure the destructor is virtual
| CAttributedData ()
| CAttributedData (const CAttributedData &org)
| CAttributedData (PAttributeMap attr)
CAttributedData & | operator= (const CAttributedData &org)
| Assignemt operator.
const PAttribute | get_attribute (const std::string &key) const
CAttributeMap::const_iterator | begin_attributes () const
CAttributeMap::const_iterator | end_attributes () const
void | set_attribute (const std::string &key, PAttribute attr)
void | set_attributes (CAttributeMap::const_iterator begin, CAttributeMap::const_iterator end)
void | set_attribute (const std::string &key, const std::string &value)
template<typename T>
void | set_attribute (const std::string &key, const T &value)
void | set_attribute (const std::string &key, const char *value)
const std::string | get_attribute_as_string (const std::string &key) const
| returns the requested attribute as string, returns an empty string if attribute doesn't exist
template<typename T>
const T | get_attribute_as (const std::string &key) const
template<typename T>
const T | get_attribute_as (const std::string &key, T default_value) const
void | delete_attribute (const std::string &key)
bool | has_attribute (const std::string &key) const
void | print (std::ostream &os) const

## Static Public Attributes

static const char * | data_descr

## Detailed Description

a 3D field of floating point single accuracy 3D vectors

Definition at line 102 of file 3d/vectorfield.hh.

## Member Function Documentation

## update_as_inverse_of()

void C3DFVectorfield::update_as_inverse_of | ( | const C3DFVectorfield & | other,
|  | float | tol,
|  | int | maxiter )

evaluate this vector field as the inverse of another

This functions corrects the vector field to describe the inverse transformation of a given input vector field

Parameters

  other | the vector field this one should be inverse of
  tol | tolerance for inverse accuracy
  maxiter | maximum number of interations for one vector to be optimized

## update_by_velocity()

void C3DFVectorfield::update_by_velocity | ( | const C3DFVectorfield & | velocity_field,
|  | float | time_step )

Update this vector field by using a velocity field

Parameters

  velocity_field | the velocity field
  time_step | the time step to be used for the update

## Field Documentation

## data_descr

const char* C3DFVectorfield::data_descr

static

Definition at line 105 of file 3d/vectorfield.hh.

The documentation for this class was generated from the following file:

- 3d/vectorfield.hh